
const tgraph = 100;	//таймаут ms цикла графики
const tloop = 1000;	//таймаут ms цикла данных
const Xmax = 800;
const Ymax = 400;
var U220 = Array();	//массив напряжения
var F220 = Array();	//массив частот
var dtime = Array();	//массив даты и времени

var U220max;
var U220min;
var F220max;
var F220min;

var GU220s;
var scale;
var startscale;
var GF220s;
var fscale;
var fstartscale;

var DataFlag;

//
function MyStart() {
	//
	InitGrarhSVG("MySVG", Xmax, Ymax); //инициализируем холст
	GrawGrid();	//рисуем сетку
	SetPatternSVG(); //принимаем весь холст с сеткой как шаблон
	DataFlag = false;
	//активация "циклов"
	MyLoop();
	LoopGraph();
}

//Запросы серверу
var dbI;
function LoadIndex() {
	var str;
	var xmlHttp = new XMLHttpRequest();
	xmlHttp.onreadystatechange = function () {
	if(xmlHttp.readyState == 4) {
		if(xmlHttp.status == 200) {
			str = xmlHttp.responseText;
			//document.getElementById("test").innerHTML = str;
			dbI = eval('(' + str +')');
			ParseIndex();
			}
		}
	}
	xmlHttp.open("GET", "MyPHP.php?dtime=" + new Date().getTime(), true);
	xmlHttp.send();
}

function ParseIndex() {
	var cnt = 0;
	U220max = 0;
	U220min = 999;
	F220max = 0;
	F220min = 999;
	//определяем максимумы и минимумы параметров и заполнение массивов
	while(cnt < 800) {
		U220[cnt] = parseFloat(dbI.U220[cnt]);
		if(U220max < U220[cnt]) U220max = U220[cnt];
		if(U220min > U220[cnt]) U220min = U220[cnt];
		F220[cnt] = parseFloat(dbI.F220[cnt]);
		if(F220max < F220[cnt]) F220max = F220[cnt];
		if(F220min > F220[cnt]) F220min = F220[cnt];
		dtime[cnt] = parseInt(dbI.dtime[cnt], 10);
		cnt++;
	}
	//напряжение
	if((Math.abs(U220max - 230) < 4) && (Math.abs(U220min - 230) < 4)) {
		GU220s = 50;	//200px / 4v
		scale = 2;
		startscale = 226;
	} else	if((Math.abs(U220max - 230) < 10) && (Math.abs(U220min - 230) < 10)) {
		GU220s = 20;	//200px / 10v
		scale = 5;
		startscale = 220;
	} else if((Math.abs(U220max - 230) < 20) && (Math.abs(U220min - 230) < 20)) {
		GU220s = 10;	//200px / 20v
		scale = 10;
		startscale = 210;
	} else if((Math.abs(U220max - 230) < 40) && (Math.abs(U220min - 230) < 40)) {
		GU220s = 5;		//200px / 40v
		scale = 20;
		startscale = 190;
	} else if((Math.abs(U220max - 230) < 100) && (Math.abs(U220min - 230) < 100)) {
		GU220s = 2;		//200px / 100v
		scale = 50;
		startscale = 130;
	} else if((Math.abs(U220max - 230) < 200) && (Math.abs(U220min - 230) < 200)) {
		GU220s = 1;		//200px / 200v
		scale = 100;
		startscale = 30;
	} /*else if((Math.abs(U220max - 230) < 230) && (Math.abs(U220min - 230) < 230)) {
		GU220s = 1;
		scale = 115;
		startscale = 0;
	}*/
	//частота
	if((Math.abs(F220max - 50) < 0.01) && (Math.abs(F220min - 50) < 0.01)) {
		GF220s = 10000;
		fscale = 0.01;
		fstartscale = 49.98;
	} else if((Math.abs(F220max - 50) < 0.1) && (Math.abs(F220min - 50) < 0.1)) {
		GF220s = 1000;
		fscale = 0.1;
		fstartscale = 49.8;
	} else if ((Math.abs(F220max - 50) < 2) && (Math.abs(F220min - 50) < 2)) {
		GF220s = 100; // 200px / 2Hz
		fscale = 1;
		fstartscale = 48; //49.8;
	} else if ((Math.abs(F220max - 50) < 5) && (Math.abs(F220min - 50) < 5)) {
		GF220s = 40; //200px / 5Hz
		fscale = 2.5;
		fstartscale = 45;
	}   else { //if ((Math.abs(F220max - 50) < 10) && (Math.abs(F220min - 50) < 10)) {
		GF220s = 20; //200px / 10Hz
		fscale = 10;
		fstartscale = 30;
	}
	//
	DataFlag = true;
}

//цикл данных
function MyLoop() {
	LoadIndex();
	 setTimeout(MyLoop, tloop);
}


//сетка
function GrawGrid() {
	var cnt = 0;
	while(cnt < 5) {
		DrawLine("GRH" + cnt, 0, Ymax - (cnt * 100), Xmax, Ymax - (cnt * 100), "1px", "rgb(100,100,100)" );
		cnt++;
	}
	cnt = 0;
	while(cnt < 9) {
		DrawLine("GRv" + cnt, cnt * 100, 0, cnt * 100, Ymax, "1px", "rgb(100,100,100)" );
		cnt++;
	}
}

function timeConverter(UNIX_timestamp, fdate) {
	var a = new Date(UNIX_timestamp);
	var monts = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
	var year = a.getFullYear();
	var mont = monts[a.getMonth()];
	var date = a.getDate();
	if(date < 10)
		date = "0" + date;
	var hour = a.getHours();
	if(hour < 10)
		hour = "0" + hour;
	var min = a.getMinutes();
	if(min < 10)
		min = "0" + min;
	var sec = a.getSeconds();
	if(sec < 10)
		sec = "0" + sec;
	if(fdate > 0) {
		var outstr = date + "." + mont + "." + year;
	} else {
		var outstr = hour + ":" + min + ":" + sec;
	}
	return outstr;
}

//цикл графики
function LoopGraph() {
	ClearGraphSVG(); //обновляем холст из шаблона, а не рисуем каждый раз
	//
	if(DataFlag == true) {
		var cnt = 0;
		var sx = 1;
		var x1 = 0;
		while(cnt < 799) {
			var x2 = x1 + sx;
			if(cnt == 0) {
				DrawText("rU220t", 5, 15, '12px', "rgb(255,0,0)", U220[cnt] + "V");
			}
			DrawLine("U220" + cnt, x1, 201 - ((U220[cnt] - 230) * GU220s), x2, 201 - ((U220[cnt + 1] - 230) * GU220s), "1px", "rgb(255,0,0)" );
			x1 = x2;
			cnt++;
		}
		var x1 = 0;
		cnt = 0;
		while(cnt < 799) {
			var x2 = x1 + sx;
			if(cnt == 0) {
				DrawText("rF220t", 5, 27, '12px', "rgb(0,255,0)", F220[cnt] + "Hz");
			}
			DrawLine("F220" + cnt, x1, 201 - ((F220[cnt] - 50) * GF220s), x2, 201 - ((F220[cnt + 1] - 50) * GF220s), "1px", "rgb(0,255,0)" );
			x1 = x2;
			cnt++;
		}
		cnt = 1;
		while(cnt < 4) {
			var uf = Math.round((startscale + (cnt * scale)) * Math.pow(10,2)) / Math.pow(10,2);
			DrawText("U220t" + cnt, 105, 401 - (cnt * 100) - 5, '12px', "rgb(255,0,0)", uf + "V");
			var df = Math.round((fstartscale + (cnt * fscale)) * Math.pow(10,2)) / Math.pow(10,2);
			DrawText("F220t" + cnt, 705, 401 - (cnt * 100) - 5, '12px', "rgb(0,255,0)", df + "Hz");
			cnt++;
		}
		var uf = Math.round((startscale + (cnt * scale)) * Math.pow(10,2)) / Math.pow(10,2);
		DrawText("U220t" + cnt, 105, 401 - (cnt * 100) + 15, '12px', "rgb(255,0,0)", uf + "V");
		var df = Math.round((fstartscale + (cnt * fscale)) * Math.pow(10,2)) / Math.pow(10,2);
		DrawText("F220t" + cnt, 705, 401 - (cnt * 100) + 15, '12px', "rgb(0,255,0)", df + "Hz");
		cnt = 0;
		while(cnt < 8) {
			var Dstr = timeConverter(dtime[cnt * 100] * 1000, 255);
			var Tstr = timeConverter(dtime[cnt * 100] * 1000, 0);
			DrawText("Date" + cnt, (cnt * 100) + 5, 401 - 5, '12px', "white", Dstr);
			DrawText("Time" + cnt, (cnt * 100) + 5, 401 - 17, '12px', "white", Tstr);
			cnt++;
		}
	}
	
	setTimeout(LoopGraph, tgraph);
}